Thread (4 messages) flat view 4 messages, 2 authors, 2016-06-15

Re: git-svn: Fails to drop leading path from empty dir name

From: Björn Steinbrink <hidden>
Date: 2016-06-15 22:47:45
Subsystem: the rest · Maintainer: Linus Torvalds

Hi Eric,

On 2009.11.22 15:25:04 -0800, Eric Wong wrote:
Björn Steinbrink [off-list ref] wrote:
I'm having a bit of trouble figuring out exactly what you mean
here, can you double check your tests?  Annotations below, thanks
quoted
+test_expect_success 'clone trunk' 'git svn clone -s "$svnrepo" trunk'
                                                    ^^            ^^^^^
                                                           Huh?
quoted
+test_expect_success 'empty directories in trunk exist' '
+	(
+		cd cloned &&
                   ^^^^^^ - ?
quoted
+		for i in trunk/a trunk/"weird file name"
Argh, yeah, I messed that patch up, the test only failed because I also
messed up this line, adding the trunk prefix there, too. Fixed patch
below.

SVN Repo layout:

/
|
|---trunk
|   |
... |---foo/ # Empty
    |
    |---bar/
        |
        somefile

with "git svn clone -s svn://host/path/to/repo you get:

.git
bar/
bar/somefile
trunk/foo # This should be just foo/

i.e. the empty directories have their path relative to the repo root,
instead of relative to the directory the git branch is associated with.

Sorry for the messed up first patch.

Björn
diff --git a/t/t9146-git-svn-empty-dirs.sh b/t/t9146-git-svn-empty-dirs.sh
index 5948544..70c52c1 100755
--- a/t/t9146-git-svn-empty-dirs.sh
+++ b/t/t9146-git-svn-empty-dirs.sh
@@ -82,4 +82,27 @@ test_expect_success 'git svn mkdirs -r works' '
 	)
 '
 
+test_expect_success 'initialize trunk' '
+	for i in trunk trunk/a trunk/"weird file name"
+	do
+		svn_cmd mkdir -m "mkdir $i" "$svnrepo"/"$i"
+	done
+'
+
+test_expect_success 'clone trunk' 'git svn clone -s "$svnrepo" trunk'
+
+test_expect_success 'empty directories in trunk exist' '
+	(
+		cd trunk &&
+		for i in a "weird file name"
+		do
+			if ! test -d "$i"
+			then
+				echo >&2 "$i does not exist"
+				exit 1
+			fi
+		done
+	)
+'
+
 test_done
Keyboard shortcuts
hback out one level
jnext message in thread
kprevious message in thread
ldrill in
Escclose help / fold thread tree
?toggle this help